/*
 * Copyright (c) 1998 by Interdisciplinary Center Herzliya
 * All rights reserved.
 *
 * Permission is hereby granted, without written agreement and without
 * license or royalty fees, to use, copy, modify, and distribute this
 * software and its documentation for any purpose, provided that the
 * above copyright notice and the following two paragraphs appear in
 * all copies of this software.
 *
 * IN NO EVENT SHALL THE INTERDISCIPLINARY CENTER HERZLIYA BE LIABLE
 * TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR
 * CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OF THIS SOFTWARE AND
 * ITS DOCUMENTATION, EVEN IF THE INTERDISCIPLINARY CENTER HERZLIYA
 * HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * THE INTERDISCIPLINARY CENTER HERZLIYA SPECIFICALLY DISCLAIMS ANY
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE 
 * SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE
 * INTERDISCIPLINARY CENTER HERZLIYA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 * */

// $Header: /usr/u/raoul/cvs/cs415-storage-server/il/ac/idc/storage/Lookup.java,v 1.1.1.1 1999/09/17 18:07:27 raoul Exp $ 

package il.ac.idc.storage;

import java.io.*;

public class Lookup extends Message {
  public Credentials cred;
  public StorageID dir;

  public String name;

  /** Create a Lookup message to be sent.
  */
  public Lookup(Credentials c, StorageID d, String nam) {
    marker = Message.Lookup;
    cred = c;
    dir = d;
    name = nam;
    uniq=0;
  }

  /** Create a Lookup message to be sent.
  */
  public Lookup(Credentials c, StorageID d, String nam, int Uniq) {
    marker = Message.Lookup;
    cred = c;
    dir = d;
    name = nam;
    uniq=Uniq;
  }

  public String toString() {
    return "Lookup: " + dir + ", " + "[" + name + "]"  + ", u: " + uniq;
  }

  /** Create a Lookup message from a stream */
  Lookup(DataInputStream istr) 
  throws IOException {
    int strlen;
    StringBuffer buff;

    marker = Message.Lookup;
    cred = new Credentials(istr.readLong());
    dir = new StorageID(istr.readLong());
    
    strlen = istr.readInt();
    uniq = istr.readInt();
    buff = new StringBuffer(strlen);
    for (int i = 0; i <  strlen; i++) {
      buff.append(istr.readChar());
    }
    name = buff.toString();
  }
  
  // Still have to send the data.
  public void sendMessage(DataOutputStream ostr) 
    throws IOException {
    ostr.writeInt(marker);
    ostr.writeLong(cred.toLong()); 
    ostr.writeLong(dir.toLong());
    ostr.writeInt(name.length());
    ostr.writeInt(uniq);
    ostr.writeChars(name);
    ostr.flush();    
  }  
}
